unit beltpich;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm3 = class(TForm)
    Image2: TImage;
    Image1: TImage;
    RadioButton5: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton1: TRadioButton;
    Label4: TLabel;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure RadioButton1KeyPress(Sender: TObject; var Key: Char);
    procedure RadioButton2KeyPress(Sender: TObject; var Key: Char);
    procedure RadioButton3KeyPress(Sender: TObject; var Key: Char);
    procedure RadioButton4KeyPress(Sender: TObject; var Key: Char);
    procedure RadioButton5KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); Override;
  public
    { Public 錾 }
  end;

var
  Form3: TForm3;

implementation

uses lengcalc, pullynum, Belttype;

{$R *.DFM}

procedure TForm3.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  BorderStyle := bsSingle;
  BorderIcons := [biSystemMenu,biminimize];
  top := Form1.top;
  left := Form1.left;
  Caption := 'xg̃sb`̑I            ' + Verstring;
  ClientHeight := 350;
  ClientWidth := 500;
  with BitBtn1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 18;
    width := 121;
    height := 33;
    top := 120;
    left := 24;
  end;
  with BitBtn2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 18;
    width := 48;
    height := 33;
    top := 184;
    left := 24;
  end;
  with BitBtn3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := ClRed;
    Font.Style := [fsBold,fsItalic];
    Font.Height := 18;
    width := 48;
    height := 33;
    top := 184;
    left := 96;
  end;
  with Label1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := clMaroon;
    Font.Style := [fsBold];
    Font.Height := 18;
    top := 8;
    left := 64;
  end;
  with Label2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := clblack;
    Font.Style := [fsBold];
    Font.Height := 18;
    top := 40;
    left := 24;
  end;
  with Label3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := clRed;
    Font.Style := [fsBold];
    Font.Height := 18;
    top := 80;
    left := 24;
  end;
  with Label4 do begin
    Font.Name := 'lr oSVbN';
    Font.color := clMaroon;
    Font.Style := [fsBold];
    Font.Height := 14;
    top := 240;
    left := 24;
  end;
  with RadioButton1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    width := 57;
    height := 25;
    top := 40;
    left := 168;
  end;
  with RadioButton2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    width := 57;
    height := 25;
    top := 80;
    left := 168;
  end;
  with RadioButton3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    width := 57;
    height := 25;
    top := 120;
    left := 168;
  end;
  with RadioButton4 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    width := 57;
    height := 25;
    top := 160;
    left := 168;
  end;
  with RadioButton5 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    width := 57;
    height := 25;
    top := 200;
    left := 168;
  end;
  with Image1 do begin top := 80; left := 250; width := 200; height := 200; end;
  with Image2 do begin top := 80; left := 250; width := 200; height := 200; end;
  Label4.top := 330;
end;

procedure TForm3.FormResize(Sender: TObject);
begin
  top := Form1.top;
  left := Form1.left;
  ClientHeight := 350;
  ClientWidth := 500;
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.show;
end;

procedure TForm3.RadioButton1Click(Sender: TObject);
begin
  Label3.caption := 'sb`PDT';
  pich := 1.5;
end;

procedure TForm3.RadioButton2Click(Sender: TObject);
begin
  Label3.caption := 'sb`QDO';
  pich := 2.0;
end;

procedure TForm3.RadioButton3Click(Sender: TObject);
begin
  Label3.caption := 'sb`QDT';
  pich := 2.5;
end;

procedure TForm3.RadioButton4Click(Sender: TObject);
begin
  Label3.caption := 'sb`RDO';
  pich := 3.0;
end;

procedure TForm3.RadioButton5Click(Sender: TObject);
begin
  Label3.caption := 'sb`TDO';
  pich := 5.0;
end;

procedure pichout;{sb`͏}
begin
  if pich >= 1.5 then
    begin
      Form4.show;
      Form3.hide;
      Form4.top := Form1.top;
      Form4.left := Form1.left;
      Form4.Label4.Caption := '';
      Form4.Edit1.setFocus;
    end;
end;

procedure TForm3.BitBtn1Click(Sender: TObject);
begin
  pichout;{sb`͏}
end;

procedure TForm3.BitBtn2Click(Sender: TObject);
begin
  Form2.show;
  hide;
  Form2.top := Form1.top;
  Form2.left := Form1.left;
end;

procedure TForm3.BitBtn3Click(Sender: TObject);
begin
  hide;
  Form1.show;
end;

procedure TForm3.RadioButton1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then pichout;{sb`͏}
end;

procedure TForm3.RadioButton2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then pichout;{sb`͏}
end;

procedure TForm3.RadioButton3KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then pichout;{sb`͏}
end;

procedure TForm3.RadioButton4KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then pichout;{sb`͏}
end;

procedure TForm3.RadioButton5KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then pichout;{sb`͏}
end;

end.

