unit datain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Buttons, ExtCtrls, System.UITypes;

  procedure gridsetup;{WObh̐ݒ}

type
  TForm5 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    BitBtn4: TBitBtn;
    Image1: TImage;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private 錾 }
    procedure SaveData; //̓f[^[t@C
  protected
    procedure CreateParams(var Params: TCreateParams); Override;
  public
    { Public 錾 }
  end;

var
  Form5: TForm5;
  inCol,inROW:  longint;  {Z̏ꏊ}
  Lcheck:       string;   {Z`FbNp}
  gridflg:      integer;  {̓G[tO}

implementation

uses Lengcalc, pullynum, display;

{$R *.DFM}

procedure TForm5.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure TForm5.SaveData; // ̓f[^[t@C
var
    II : integer;
begin
  Writeln(F1,btype);     // xg̎
  Writeln(F1,n);         // v[[̐
  Writeln(F1,pich);      // xg̃sb`
  for II := 0 to n - 1 do
    begin
      Writeln(F1,StringGrid1.Cells[1,II+1]);
      Writeln(F1,StringGrid1.Cells[2,II+1]);
      Writeln(F1,StringGrid1.Cells[3,II+1]);
    end;
end;

procedure TForm5.FormCreate(Sender: TObject);
begin
  BorderStyle := bsSingle;
  BorderIcons := [biSystemMenu,biminimize];
  caption := 'v[[̍W̓            ' + Verstring;
  top := Form1.top;
  left := Form1.left;
  ClientHeight := 400;
  ClientWidth := 600;
  with Bitbtn1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    top := 330;
    left := 100;
    width := 129;
    height := 30;
  end;
  with Bitbtn2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 16;
    top := 365;
    left := 100;
    width := 49;
    height := 25;
    end;
  with Bitbtn3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := ClRed;
    Font.Style := [fsBold, fsItalic];
    Font.Height := 16;
    top := 365;
    left := 180;
    width := 49;
    height := 25;
  end;
  with Bitbtn4 do begin
    Font.Name := 'lr oSVbN';
    Font.color := ClBlue;
    Font.Style := [fsBold];
    Font.Height := 14;
    top := 365;
    left := 300;
    width := 150;
    height := 25;
  end;
  Canvas.Font.Name := 'lr SVbN';
  Canvas.Font.color := Clblack;
  Canvas.Font.Style := [fsBold];
  Canvas.Font.Height := 12;
  with Image1 do begin
    top := 20;
    left := 380;
    width := 200;
    height := 250;
  end;
  with Label1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 18;
  end;
  with Label2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := ClRed;
    Font.Style := [fsBold];
    Font.Height := 18;
  end;
  with Label3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblue;
    Font.Style := [fsBold];
    Font.Height := 18;
  end;
  with Label4 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblue;
    Font.Style := [fsBold];
    Font.Height := 18;
  end;
  with Label5 do begin
    Font.Name := 'lr oSVbN';
    Font.color := ClBlack;
    Font.Style := [fsBold,fsItalic];
    Font.Height := 14;
    caption := '\́L[@́@}EXňړB';
    top := 340;
    left :=250;
  end;
end;

procedure TForm5.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.show;
end;

procedure gridsetup;{WObh̐ݒ}
var
   JJ: integer;
begin
  with Form5 do begin
    with StringGrid1 do begin
      Font.Name := 'lr SVbN';
      Font.Height := 15;
      Visible := true;
      ColCount := 4;
      rowCount := n + 1;
      left := 50;
      top := 40;
      DefaultRowHeight := 20;
      ColWidths[0] := 40;
      ColWidths[1] := 80;
      ColWidths[2] := 80;
      ColWidths[3] := 80;
      if n <= 10 then Clientheight := (DefaultRowHeight + 1) * (n + 1)
                 else Clientheight := (DefaultRowHeight + 1) * 11;
      for jj := 1 to n do Cells[0 , jj] := intTostr(jj);
      setfocus;
      Font.color := Clblack;
      Font.Style := [fsBold];
      Cells[1 , 0] := 'wW';
      Cells[2 , 0] := 'xW';
      if btype = 1 then Cells[3 , 0] := '@a';
      if btype = 2 then Cells[3 , 0] := ',a';
      if (btype = 3) or  (btype = 4) then Cells[3 , 0] := '@';
      Options := [goFixedHorzLine,goHorzLine,
                       goFixedVertLine,goVertLine,goRangeSelect,goEditing,goAlwaysShowEditor];
      ClientWidth := 41 + 81 + 81 + 81;
    end;
    Label3.top := 285;
    Label3.left := 30;
    Label4.top := 305;
    Label4.left := 30;
    if btype =1 then
      begin
        Label3.caption := 'v[[xg̊ȌꍇAaɁg|htB';
        Label4.caption := 'xǧɉĔa␳鎖';
      end;
    if btype =2 then
      begin
        Label3.caption := 'v[[xg̊ȌꍇAaɁg|htB';
        Label4.caption := 'xǧɂ锼a̕␳KvȂB';
      end;
    if btype =3 then
      begin
        Label3.caption := 'v[[xg̊ȌꍇAɁg|htB';
        Label4.caption := 'xǧɂ锼a̕␳KvȂB';
      end;
    if btype =4 then
      begin
        Label3.caption := '۹Ĥ߰ذݤ߰ذ̊ȌꍇAɁg|htB';
        Label4.caption := 'xǧɂ锼a̕␳KvȂB';
      end;
  end;
end;

procedure TForm5.BitBtn3Click(Sender: TObject);
begin
  hide;
  Form1.show;
end;

procedure TForm5.BitBtn2Click(Sender: TObject);
begin
  Form4.show;
  hide;
end;

procedure TForm5.StringGrid1SelectCell(Sender: TObject; Col, Row: Longint; var CanSelect: Boolean);
label
  selout;
var
  Kj,kdin1,Llengs: integer;
  Kchchar:          char;
begin
  Lcheck  := StringGrid1.Cells[inCol,inROW];
  Llengs  := Length(Lcheck);
  kdin1   := 0;
  for Kj := 1 to Llengs do
    begin
      Kchchar := Lcheck[KJ];
      if  (Kj = 1) and (Kchchar = '-') then Kchchar := '0';
      case Kchchar of
        '0'..'9':;
             '.': Kdin1 := Kdin1 + 1;
              #0: break;
      else
        goto selout;
      end;
    end;
  if Kdin1 > 1 then goto selout;
  inCol := Col;
  inRow := Row;
  exit;
selout:
  StringGrid1.Cells[inCol,inROW] := 'G[';
  inCol := Col;
  inRow := Row;
end;

procedure datagrid;{f[^[}
label selout;
var
  Kj,GC,GR,kdin1,Llengs: integer;
  Kchchar:          char;
begin
// Obh ̓~X`FbN  ͂̓`FbNȂ
  for GC := 1 to 3  do
    for GR := 1 to n do
      begin
        Lcheck := Form5.StringGrid1.Cells[GC,GR];
        Llengs := Length(Lcheck);
        kdin1 := 0;
        for Kj := 1 to Llengs do
          begin
            Kchchar := Lcheck[KJ];
            if  (Kj = 1) and (Kchchar = '-') then Kchchar := '0';
            case Kchchar of
              '0'..'9':;
                   '.': Kdin1 := Kdin1 + 1;
                    #0: break;
              else goto selout;         // ̓~X
            end;
          end;
        if Kdin1 > 1 then goto selout;  // ̓~X
      end;
// ̓`FbNƐlϊ
  gridflg := 1;{̓~X}
  GC := 1;
  for GR := 1 to n do        // XW
    begin
      Lcheck := Form5.StringGrid1.Cells[GC,GR];
      if Lcheck = '' then X[GR]   := 0
                     else X[GR]   := strToFloat(Lcheck);
      if Lcheck = '' then gridflg := 3;{̓~XL}
    end;
  GC := 2;
  for GR := 1 to n do        // YW
    begin
      Lcheck := Form5.StringGrid1.Cells[GC,GR];
      if Lcheck = '' then Y[GR]   := 0
                     else Y[GR]   := strToFloat(Lcheck);
      if Lcheck = '' then gridflg := 4;{̓~XL}
    end;
  GC := 3;
  for GR := 1 to n do        // v[[AAChv[[a
    begin
      Lcheck := Form5.StringGrid1.Cells[GC,GR];
      if Lcheck = '' then teeth[GR] := 0
                     else teeth[GR] := strToFloat(Lcheck);
      if Teeth[GR] = 0 then gridflg := 5;{̓~XL}
    end;
  exit;
selout:
  gridflg := 2;{̓~XL}
end;

procedure TForm5.BitBtn1Click(Sender: TObject);
var
  JJ :    integer;
begin
  datagrid;{f[^[}
  if gridflg = 1 then
    begin
      // xǧ␳lvZ  Ў^C~OxgOv[[p
      if (btype > 1) and (btype < 4) then
                sick := 0.629 / Exp(ln(3)*1.4) * Exp(ln(pich)*1.4);{xǧ̋ߎl߂}
      // v[[^CvŃsb`~avZ
      for  JJ := 1 to n do
        begin
          case btype of
            1:  R[JJ] := teeth[JJ];                                      // Pv[[
            2:  if teeth[JJ] > 0 then R[JJ] := pich * teeth[JJ] / 2 / pi // Ў^C~Oxg
                                 else R[JJ] := teeth[JJ] - sick;         // Ў^C~OOv[[
          3,4:  R[JJ] := pich * teeth[JJ] / 2 / pi;                      // ^C~Oxg̓`F[
          end;
        end;
      with Form6 do begin
        Edit3.Visible       := False;
        Label1.Visible      := False;
        BitBtn6.Visible     := False;
        Label2.Visible      := False;
        Label3.Visible      := False;
        Edit1.Visible       := False;
        Image2.Visible      := False;
        BitBtn7.Visible     := False;
        BitBtn8.Visible     := False;
        BitBtn9.Visible     := False;
        Edit2.Visible       := False;
        SpinButton1.Visible := False;
        show;
      end;
      hide;
      ATF := 0;
      btn6flag := 0;
      displayin;{v[[\}
      if ATF = 1 then ShowMessage('v[[');
    end;
  if gridflg = 2 then ShowMessage('̓~XL');
  if gridflg = 3 then ShowMessage('wW͂L');
  if gridflg = 4 then ShowMessage('xW͂L');
  if gridflg = 5 then ShowMessage('aA  ͂L ͂Oi[j');
end;

procedure TForm5.BitBtn4Click(Sender: TObject);
var
    sii : string;
begin
  datagrid;{f[^[}
  if gridflg = 2 then ShowMessage('̓~XL');
  if gridflg = 3 then ShowMessage('wW͂L');
  if gridflg = 4 then ShowMessage('xW͂L');
  if gridflg = 5 then ShowMessage('aA  ͂L ͂Oi[j');
  if gridflg <> 1 then exit;
  if SaveDialog1.Execute then
    begin
      sii:= ExtractFileExt(SaveDialog1.FileName);
      if sii = '' then sii:= ChangeFileExt(SaveDialog1.FileName,'.Ply')
                  else sii:= SaveDialog1.FileName;
      if FileExists(Sii) then
                if MessageDlg('Ƀt@C݂܂㏑܂' + #13#10
                                + ExtractFileName(sii) + '?',
                                            mtConfirmation, [mbYes, mbNo],0) = mrNo then exit;
      AssignFile(F1, Sii);
      ReWrite(F1);
      SaveData;
      CloseFile(F1);
    end;
end;

initialization
    inCol := 1;{Z̏ꏊ0C0Ɏw}
    inRow := 1;
    gridflg := 1;{̓G[tO}

end.


