unit display;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Mask, Spin;
  procedure maindisplay;{v[[̈ʒu\}
  procedure displayin;{v[[\}

type
  TForm6 = class(TForm)
    PrinterSetupDialog1: TPrinterSetupDialog;
    Timer1: TTimer;
    Image1: TImage;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn6: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    Image2: TImage;
    SpinButton1: TSpinButton;
    BitBtn10: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2Change(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);

  private
    { Private 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); Override;
  public
    { Public 錾 }
  end;

var
  Form6: TForm6;

  btn6flag:  byte;

implementation

uses Lengcalc,calculate, pullynum, datain, datadisplay;

{$R *.DFM}

procedure TForm6.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure CLEARDIS;
var
  NewRect: TRect;
begin
  Form6.Caption := '@vZ             ' + Verstring;
  Form6.Image1.Canvas.Brush.Color := clWhite;
  NewRect := Rect(0, 0, Form6.ClientWidth, Form6.ClientHeight);
  Form6.Image1.Canvas.FillRect(NewRect);
  exit;
end;

procedure TForm6.FormCreate(Sender: TObject);
var
  Bitmap: Tbitmap;
begin
  BorderStyle := bsSizeable;
  BorderIcons := [biSystemMenu,biminimize];
  BringToFront;
  ClientHeight := 450;
  ClientWidth := 600;
  Top := (Screen.height - Height) div 2;
  Left := (Screen.Width - Width) div 2;
  Bitmap := TBitmap.Create;
  Bitmap.Width := Width;
  Bitmap.height:= height;
  with Image1 do begin
    Picture.Graphic := Bitmap;
    Canvas.Font.Height := 15;
  end;
  Bitmap.Free;
  Image2.height := 30;
  Image2.width := 100;
  Image2.top := (Image1.height - Image2.height) div 2;
  Image2.left := (Image1.Width - Image2.width - 100) div 2;
  with BitBtn1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    width := 95;
    height := 25;
    top := 50;
    left := Form6.ClientWidth - 100;
  end;
  with BitBtn2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 14;
    width := 95;
    height := 25;
    top := 80;
    left := Form6.ClientWidth - 100;
  end;
  with BitBtn3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 95;
    height := 25;
    top := 110;
    left := Form6.ClientWidth - 100;
  end;
  with BitBtn4 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 95;
    height := 25;
    left := Form6.ClientWidth - 100;
    top := 140;
  end;
  with BitBtn5 do begin
    Font.Name := 'lr oSVbN';
    Font.color := ClRed;
    Font.Style := [fsBold,fsItalic];
    Font.Height := 17;
    width := 95;
    height := 25;
    top := 170;
    left := Form6.ClientWidth - 100;
  end;
  with BitBtn10 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 13;
    width := 95;
    height := 25;
    top := 200;
    left := Form6.ClientWidth - 100;
  end;
  with Label1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 14;
    top := 160;
    left := Form6.ClientWidth - 120;
    color := Clwhite;
  end;
  with Edit3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 40;
    height := 25;
    top := 180;
    left := Form6.ClientWidth - 100;
    Edit3.Text := '';
  end;
  with Label2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    top := 220;
    left := Form6.ClientWidth - 120;
    color := Clwhite;
  end;
  with Edit1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 95;
    height := 25;
    top := 240;
    left := Form6.ClientWidth - 100;
    Edit1.Text := '';
  end;
  with Edit2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 15;
    width := 60;
    height := 20;
    top := 260;
    left := Image1.Width - 100;
  end;
  with SpinButton1 do begin
    top := 260;
    height := 23;
    width := 18;
    Left := Edit2.left + Edit2.width + image1.Canvas.textWidth('K') + 5;
  end;
  with BitBtn6 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 95;
    height := 25;
    top := 290;
    left := Form6.ClientWidth - 100;
  end;
  with Label3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 12;
    top := 135;
    left := Form6.ClientWidth - 100;
    color := clWhite;
  end;
  with BitBtn7 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 12;
    width := 40;
    height := 25;
    top := 150;
    left := Form6.ClientWidth - 100;
  end;
  with BitBtn8 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 12;
    width := 40;
    height := 25;
    top := 150;
    left := Form6.ClientWidth - 50;
  end;
  with BitBtn9 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 50;
    height := 25;
    top := 50;
    left := Form6.ClientWidth - 80;
  end;
  Form6.Timer1.Enabled := False;
  CLEARDIS;
end;

procedure Allow;forward;{\}

procedure TForm6.FormResize(Sender: TObject);
var
  Bitmap: TBitmap;
begin
  if ClientWidth < 300 then  ClientWidth := 300;
  if  ClientHeight < 300 then ClientHeight := 300;
  Bitmap := TBitmap.Create;
  Bitmap.Width := Width;
  Bitmap.height:= height;
  with Image1 do begin
    Picture.Graphic := Bitmap;
  end;
  Bitmap.Free;
  BitBtn1.left := ClientWidth - 100;
  BitBtn2.left := ClientWidth - 100;
  BitBtn3.left := ClientWidth - 100;
  BitBtn4.left := ClientWidth - 100;
  BitBtn5.left := ClientWidth - 100;
  Label1.left := ClientWidth - 120;
  Edit3.left := ClientWidth - 100;
  BitBtn6.left := ClientWidth - 100;
  Label3.left := ClientWidth - 100;
  Label2.left := ClientWidth - 120;
  Edit1.left := ClientWidth - 100;
  BitBtn7.left := ClientWidth - 100;
  BitBtn8.left := ClientWidth - 50;
  BitBtn9.left := ClientWidth - 80;
  BitBtn10.left := ClientWidth - 100;
  Image2.top := (Image1.height - Image2.height) div 2;
  Image2.left := (Image1.Width - Image2.width - 100) div 2;
  Edit2.left := Image1.Width - 100;
  Image1.Canvas.Font.Height := 15;
  SpinButton1.Left := Edit2.left + Edit2.width + image1.Canvas.textWidth('K') + 5;
  maindisplay;{v[[̈ʒu\}
  if btn6flag = 1 then Allow;{\}
end;

procedure TForm6.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.show;
end;

procedure SetCOLOR(col: integer);
begin
  with Form6.Image1.Canvas.Pen do begin
    case col of
     	0:  Color := clBlack;
     	1:  Color := clNavy;
     	2:  Color := clGreen;
     	3:  Color := clTeal;
     	4:  Color := clMaroon;
     	5:  Color := clPurple;
     	6:  Color := clOlive;
     	7:  Color := clSilver;
     	8:  Color := clGray;
     	9:  Color := clBlue;
     	10: Color := clLime;
     	11: Color := clAqua;
     	12: Color := clRed;
     	13: Color := clFuchsia;
     	14: Color := clYellow;
     	15: Color := clWhite;
    end;
  end;
end;

procedure Circle(xpos,ypos,r: double; col: integer; s,e: double);
var
  x1,y1,dltapi,arcpi,ercpi:              double;
  xxi1,yyi1:      integer;
begin
  setcolor(col);
  if e < s then ercpi := e + pi * 2
           else ercpi := e;
  x1 := cos(s) * r + xpos;
  y1 := ypos - sin(s) * r;
  xxi1 := round(x1);
  yyi1 := round(y1);
  if r < 1 then r := 1;
  dltapi := 1;
  arcpi := s + (dltapi / r / 8);
  Form6.Image1.Canvas.moveto(xxi1, yyi1);
  while ercpi > arcpi do
    begin
      if arcpi <= pi * 2 then
        begin
          x1 := cos(arcpi) * r + xpos;
          y1 := ypos - sin(arcpi) * r;
        end
        else
        begin
          x1 := cos(arcpi - pi * 2) * r + xpos;
          y1 := ypos - sin(arcpi - pi * 2) * r;
        end;
      if  (xxi1 <> round(x1)) or (yyi1 <> round(y1)) then
        begin
          xxi1 := round(x1);
          yyi1 := round(y1);
          Form6.Image1.Canvas.Lineto(xxi1, yyi1);
        end;
      dltapi := dltapi +1;
      arcpi := s + (dltapi / r / 8);
    end;
  if ercpi <= pi * 2 then
    begin
      x1 := cos(ercpi) * r + xpos;
      y1 := ypos - sin(ercpi) * r;
    end
    else
    begin
      x1 := cos(ercpi - pi * 2) * r + xpos;
      y1 := ypos - sin(ercpi - pi * 2) * r;
    end;
  if  (xxi1 <> round(x1)) or (yyi1 <> round(y1)) then
    begin
      xxi1 := round(x1);
      yyi1 := round(y1);
      Form6.Image1.Canvas.Lineto(xxi1, yyi1);
    end;
end;

procedure maindisplay;{v[[̈ʒu\}
var
   number:                   string;
   JJ,II,Xoff,Yoff,twidth:             integer;
   Xc0,Yc0,Xc1,Yc1:          integer;
   Xmax,Xmin,Ymax,Ymin: double;
   Rc,X0,X1,Y0,Y1:           double;
   Lx,Ly,Lm,Ld,Lc:           double;{͍W̑傫}
   Sic:                      double;{\{}
   Hd1:                      double;{x]}
   Hd2:                      double;{w]}
   Dxx:                      double;{w\{}
   Dyy:                      double;{x\{}
   R0,R1,sqa,eqa:            double;{t\ppx}
   Xi0,Xi1,Yi0,Yi1:          integer;
begin
  CLEARDIS;
  Subroutine.Calcmain;{vZC calculate}
  number := floatTostrF(LNGS,ffFixed,5,2);
  Rc := abs(R[1]);
  Xmax := X[1] + Rc;
  Xmin := X[1] - Rc;
  Ymax := Y[1] + Rc;
  Ymin := Y[1] - Rc;
  Rmin := Rc;
  for JJ := 2 to n do
    begin
      Rc := abs(R[JJ]);
      X0 := X[JJ] + Rc;
      X1 := X[JJ] - Rc;
      Y0 := Y[JJ] + Rc;
      Y1 := Y[JJ] - Rc;
      if Xmax < X0 then Xmax := X0;
      if Xmin > X1 then Xmin := X1;
      if Ymax < Y0 then Ymax := Y0;
      if Ymin > Y1 then Ymin := Y1;
      if Rmin > Rc then Rmin := Rc;
    end;
  if Xmax = Xmin then Xmax := Xmin + 1;
  if Ymax = Ymin then Ymax := Ymin + 1;
  Lx := Xmax - Xmin;
  Ly := Ymax - Ymin;
  with Form6 do begin
    Sic := Image1.Height / (Image1.Width - 150);
    Lm := Ly / Sic;
    Lc := Lx;
    if Lc > Lm then
      begin
        Hd2 := Lx /10;
        Lx := Lx + Hd2 * 2;
        Ld := Lx * Sic;
        Hd1 := (Ld - Ly) / 2;
      end;
    if Lc > Lm then else
      begin
        Hd1 := Ly /10;
        Ly := Ly + Hd1 * 2;
        Ld := Ly / Sic;
        Hd2 := (Ld- Lx) /2;
      end;
    Xmin := Xmin - Hd2;
    Xmax := Xmax + Hd2;
    Ymin := Ymin - Hd1;
    Ymax := Ymax + Hd1;
    Dxx := (Image1.Width - 150)/ (Xmax - Xmin);
    Dyy := Image1.Height / (Ymax - Ymin);
    with Image1.Canvas do begin
      Font.color := clRed;
      Font.Name := 'lr SVbN';
      Pen.width := 1;
      Font.height := 16;
      Font.style := [fsBold];
      TextOut(Image1.Width - 95, 20, number);
      twidth := TextWidth(number);
      Font.color := clBlack;
      TextOut(Image1.Width - 100, 3, 'S');
      TextOut(Image1.Width - 95 + twidth, 20, 'mm');
      Font.color := clRed;
      for JJ := 1 to n do
        begin
          number := intTostr(JJ);
          Rc := abs(R[JJ]) * Dxx;
          Rc := Rc - 1;
          if Rc < 10 then
            begin
              Font.style := [];
              Font.Height := round(10);
              Yoff := round(10 / 2);
            end
            else
            begin
              Font.style := [fsBold];
              Font.Height := round(Rc);
              Yoff := round(Rc / 2);
            end;
          twidth := TextWidth(number);
          Xoff := twidth div 2;
          Xc0 := round((X[JJ] - Xmin) * Dxx - Xoff);
          Yc0 := Image1.Height - round((Y[JJ] - Ymin) * Dyy) - Yoff;
          TextOut(Xc0, Yc0, number);
          X0 := (X[JJ] - Xmin) * Dxx;
          Y0 := Image1.Height - (Y[JJ] - Ymin) * Dyy;
          Circle(X0, Y0, Rc, 9, 0.0, PI * 2);
        end;
      Pen.width := 1;
      pen.color := clFuchsia;
      for JJ := 1 to n do
        begin
          if JJ = n then  II := 1
                    else II := JJ + 1;
          R0 := abs(R[JJ]);
          R1 := abs(R[II]);
          Xi0 := round((X[JJ] + Cos(EQ[JJ]) * R0 - Xmin) * Dxx);
          Yi0 := Image1.Height - round((Y[JJ] + Sin(EQ[JJ]) * R0 - Ymin) * Dyy);
          Xi1 := round((X[II] + Cos(SQ[II]) * R1 - Xmin) * Dxx);
          Yi1 := Image1.Height - round((Y[II] + Sin(SQ[II]) * R1 - Ymin) * Dyy);
          moveto(Xi0,Yi0);
          lineto(Xi1,Yi1);
        end;
      for JJ := 1 to n do
        begin
          sqa := SQ[JJ];
          eqa := EQ[JJ];
          if R[JJ] < 0 then
            begin
              sqa := EQ[JJ];
              eqa := SQ[JJ];
            end;
          if sqa < 0 then sqa := sqa + 2 * pi;
          if eqa < 0 then eqa := eqa + 2 * pi;
          X0 := (X[JJ] - Xmin) * Dxx;
          Y0 := Image1.Height - (Y[JJ] - Ymin) * Dyy;
          Rc := abs(R[JJ]) * Dxx;
          if Rc < 1 then Rc := 1;
          Circle(X0, Y0, Rc, 13, sqa, eqa);
        end;
    end;
  end;
end;

procedure TForm6.BitBtn3Click(Sender: TObject);
begin
  hide;
  with Form5 do begin
    show;
    top := Form1.top;
    left := Form1.left;
    Label4.Caption := '';
  end;
end;

procedure TForm6.BitBtn5Click(Sender: TObject);
begin
  Form6.hide;
  Form1.show;
end;

procedure TForm6.BitBtn1Click(Sender: TObject);
begin
  BitBtn5.top := 100;
  BitBtn1.Visible := False;
  BitBtn2.Visible := False;
  BitBtn3.Visible := False;
  BitBtn4.Visible := False;
  BitBtn10.Visible := False;
  SpinButton1.Visible := False;
  Label1.Visible := True;
  Edit3.Visible := True;
  BitBtn6.Visible := True;
  Edit3.SetFocus;
  Label2.Visible := True;
  Edit1.Visible := True;
  BitBtn9.Visible := True;
  btn6flag := 0;
end;

procedure qsinput;{ړf[^[}
var
  indat: string;
  lengst:   integer;
  II,din1,din2:    integer;
  check: char;
begin
  din1 := 0;
  din2 := 0;
  indat := Form6.Edit2.text;
  lengst := Length(indat);
  if lengst = 0 then
    begin
      Deginput := 0;
      Radian := 0;
      Radiax := 0;
      exit;
    end;
  for II := 1 to lengst do
    begin
      check := indat[II];
      case check of
             '-': din2 := din2 + 1;
        '0'..'9':;
             '.': din1 := din1 + 1;
              #0: break;
            else  exit;
      end;
    end;
  if (din1 > 1) or (din2 > 0) then exit;
  Deginput := strToFloat(indat);
  if (Deginput >= 360) or (Deginput < 0) then
    begin
      while Deginput >= 360 do Deginput := Deginput - 360;
      while Deginput < 0 do Deginput := Deginput + 360;
      Form6.Edit2.Text := floatTostrF(Deginput,ffFixed,3,2);
    end;
  Radian := Deginput / 180 * pi;
end;

procedure NDinput;{ړv[[ԍ̓f[^[}
var
  indat: string;
  lengst:   integer;
  II,din1,din2:    integer;
  check: char;
begin
  din1 := 0;
  din2 := 0;
  indat := Form6.Edit3.text;
  lengst := Length(indat);
  if lengst = 0 then exit;
  for II := 1 to lengst do
    begin
      check := indat[II];
      case check of
             '-': din2 := din2 + 1;
        '0'..'9':;
             '.': din1 := din1 + 1;
              #0: break;
           else   exit;
      end;
    end;
  if (din1 >0) or (din2 >0) then exit;
  ND := strToint(indat);
end;

procedure NLNGinput;{V̓f[^[}
var
  indat: string;
  lengst:   integer;
  II,din1,din2:    integer;
  check: char;
begin
  din1 := 0;
  din2 := 0;
  indat := Form6.Edit1.text;
  lengst := Length(indat);
  if lengst = 0 then exit;
  for II := 1 to lengst do
    begin
      check := indat[II];
      case check of
             '-': din2 := din2 + 1;
        '0'..'9':;
             '.': din1 := din1 + 1;
              #0: break;
           else   exit;
      end;
    end;
  if (din1 > 1) or (din2 > 0) then exit;
  CTLNG := strTofloat(indat);
end;


procedure Allow;{\}
var
  Xaly,Yaly: integer;     {󒆐SW}
  Aly:       integer;     {󔼌a}
  AlyT:      integer;     {}
  ddpi:      double;      {[px}
  Allwx0,Allwy0: integer; {[W}
  Allwx1,Allwy1: integer; {[W}
  Allwx2,Allwy2: integer; {󍶍W}
  Allwx3,Allwy3: integer; {EW}
begin
  with Form6.Image1.Canvas do begin
    Pen.width := 2;
    Pen.Color := clWhite;
    ddpi := 15 / 180 * pi;
    Aly := 30;
    AlyT := 20;
    Xaly := Form6.ClientWidth - 55;
    Yaly := 220;
    Allwx0 := Xaly + round(cos(Radian) * Aly);
    Allwy0 := Yaly - round(sin(Radian) * Aly);
    Allwx1 := Xaly - round(cos(Radian) * Aly);
    Allwy1 := Yaly + round(sin(Radian) * Aly);
    Allwx2 := Allwx0 - round(cos(Radian + ddpi) * Alyt);
    Allwy2 := Allwy0 + round(sin(Radian + ddpi) * Alyt);
    Allwx3 := Allwx0 - round(cos(Radian - ddpi) * Alyt);
    Allwy3 := Allwy0 + round(sin(Radian - ddpi) * Alyt);
    moveto(Allwx0,Allwy0);
    lineto(Allwx1,Allwy1);
    moveto(Allwx2,Allwy2);
    lineto(Allwx0,Allwy0);
    lineto(Allwx3,Allwy3);
    ddpi := 15 / 180 * pi;
    Aly := 30;
    AlyT := 20;
    Xaly := Form6.ClientWidth - 55;
    Yaly := 220;
    qsinput;{ړf[^[}
    Pen.Color := clblack;
    Allwx0 := Xaly + round(cos(Radian) * Aly);
    Allwy0 := Yaly - round(sin(Radian) * Aly);
    Allwx1 := Xaly - round(cos(Radian) * Aly);
    Allwy1 := Yaly + round(sin(Radian) * Aly);
    Allwx2 := Allwx0 - round(cos(Radian + ddpi) * Alyt);
    Allwy2 := Allwy0 + round(sin(Radian + ddpi) * Alyt);
    Allwx3 := Allwx0 - round(cos(Radian - ddpi) * Alyt);
    Allwy3 := Allwy0 + round(sin(Radian - ddpi) * Alyt);
    moveto(Allwx0,Allwy0);
    lineto(Allwx1,Allwy1);
    moveto(Allwx2,Allwy2);
    lineto(Allwx0,Allwy0);
    lineto(Allwx3,Allwy3);
    Font.height := 20;
    Font.color := clBlack;
    TextOut(Form6.Edit2.Left + Form6.Edit2.Width,Form6.Edit2.top + 3, 'K');
  end;
end;

procedure outfr;{G[tO\}
begin
  if Ctfr = 1 then ShowMessage('v[[ڌvZss\(xDATA͖ ߂ĉ)');
  if Ctfr = 2 then ShowMessage('ϓ𓚖(xDATA͖ ߂ĉ)');
  if Ctfr = 3 then ShowMessage('mfړ`FbN(xDATA͖ ߂ĉ)');
  if Ctfr <> 0 then
    begin
      Form6.Image1.Canvas.pen.color := clBlack;
      Allow;{\}
      Form6.BitBtn9.SetFocus;
      Ctfr := 0;
      btn6flag := 1;
      exit;
    end;
  if Ctfr = 0 then btn6flag := 2;
end;

procedure displayin;{v[[\}
begin
  maindisplay;{v[[̈ʒu\ Display}
  with Form6 do begin
    BitBtn1.Visible     := True;
    BitBtn2.Visible     := True;
    BitBtn3.Visible     := True;
    BitBtn4.Visible     := True;
    BitBtn10.Visible    := True;
    BitBtn5.top         := 170;
    BitBtn5.Visible     := True;
    Image2.Visible      := False;
    Edit3.Visible       := False;
    Label1.Visible      := False;
    BitBtn6.Visible     := False;
    SpinButton1.Visible := False;
    Label2.Visible      := False;
    Edit1.Visible       := False;
    Label3.Visible      := False;
    BitBtn7.Visible     := False;
    BitBtn8.Visible     := False;
    BitBtn9.Visible     := False;
    Edit2.Visible       := False;
  end;
end;

procedure Radiaxset;//ړ͉ʐݒ
begin
  with Form6 do begin
    BitBtn7.Visible     := True;
    BitBtn8.Visible     := True;
    BitBtn9.Visible     := True;
    Label3.Visible      := True;
    Label1.Visible      := False;
    Edit3.Visible       := False;
    Label2.Visible      := False;
    Edit1.Visible       := False;
    Edit2.Visible       := true;
    SpinButton1.Visible := true;
    Ctfr                := 0;
    Radian              :=0;
    Radiax              :=0;{px͔{ 128 łRUOx}
    Image1.Canvas.Pen.Color := clblack;
    Allow;{\}
    btn6flag            := 1;
    BitBtn8.SetFocus;
  end;
end;

procedure TForm6.BitBtn6Click(Sender: TObject);
begin
  if btn6flag = 0 then
    begin
      NDinput;{ړv[[ԍ̓f[^[}
      if (ND < 1) or (ND > n) then exit;
      NLNGinput;{V̓f[^[}
      if  CTLNG <= 0 then exit;
      Radiaxset;//ړ͉ʐݒ
      exit;
    end;
  if btn6flag = 1 then
    begin
      Subroutine.Lengs;{w蒷vZ}
      if btn6flag = 1 then
        begin
          maindisplay;{v[[̈ʒu\}
          outfr;{G[tO\}
        end;
      if btn6flag = 2 then
        begin
          displayin;{v[[\}
          BitBtn2.SetFocus;
        end;
    end;
end;

procedure Degdown;
begin
  if Radian <> 0 then Radiax := round(Radian / pi * 90);
  Radiax := Radiax - 1;
  if Radiax < 0 then Radiax := 180;
  Form6.Edit2.text := floatTostrF(360 / 180 * Radiax,ffFixed,3,2);
end;

procedure DegUp;
begin
  if Radian <> 0 then Radiax := round(Radian / pi * 90);
  Radiax := Radiax + 1;
  if Radiax > 180 then Radiax := 0;
  Form6.Edit2.text := floatTostrF(360 / 180 * Radiax,ffFixed,3,2);
end;

procedure TForm6.BitBtn7Click(Sender: TObject);
begin
  Degdown;
end;

procedure TForm6.BitBtn8Click(Sender: TObject);
begin
  DegUp;
end;

procedure TForm6.BitBtn9Click(Sender: TObject);
begin
  displayin;{v[[\}
  Bitbtn3.SetFocus;
end;

procedure TForm6.BitBtn10Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TForm6.BitBtn2Click(Sender: TObject);
begin
  Form7.show;
  hide;
  Form7.top := Form1.top;
  Form7.left := Form1.left;
  Form7.Image1.Visible := False;
  dataoutgridsetup;{WObh̐ݒ}
end;

procedure TForm6.BitBtn4Click(Sender: TObject);
begin
  Subroutine.mainprint;{v[[̈ʒu\v^[o}
end;

procedure TForm6.Timer1Timer(Sender: TObject);
begin
  Image2.Visible := False;
  Timer1.Enabled := False;
end;

procedure TForm6.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    begin
      Edit1.setfocus;
      key := #0;
    end;
end;

procedure TForm6.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    begin
      NDinput;{ړv[[ԍ̓f[^[}
      if (ND < 1) or (ND > n) then exit;
      NLNGinput;{V̓f[^[}
      if  CTLNG <= 0 then exit;
      Radiaxset;//ړ͉ʐݒ
      key := #0;
    end;
end;

procedure TForm6.Edit2Change(Sender: TObject);
begin
  Allow;{\}
end;

procedure TForm6.SpinButton1DownClick(Sender: TObject);
begin
  Degdown;
end;

procedure TForm6.SpinButton1UpClick(Sender: TObject);
begin
  Degup;
end;

initialization
  btn6flag := 0;

end.

