unit datadisplay;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, printers, ExtCtrls;
  procedure dataoutgridsetup;{WObh̐ݒ}

type
  TForm7 = class(TForm)
    PrinterSetupDialog1: TPrinterSetupDialog;
    Timer1: TTimer;
    Image1: TImage;
    BitBtn4: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure StringGrid1Exit(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); Override;
  public
    { Public 錾 }
  end;

var
  Form7: TForm7;

implementation

uses Lengcalc, display, calculate;

{$R *.DFM}

procedure TForm7.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure TForm7.FormCreate(Sender: TObject);
begin
  BorderStyle := bsSingle;
  BorderIcons := [biSystemMenu,biminimize];
  caption := 'vZʂ̕\             ' + Verstring;
  top := Form1.top;
  left := Form1.left;
  ClientHeight := 350;
  ClientWidth := 600;
  with BitBtn1 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 81;
    height := 25;
    top := 100;
    left := Form7.ClientWidth - 100;
  end;
  with BitBtn2 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 17;
    width := 81;
    height := 25;
    top := 130;
    left := Form7.ClientWidth - 100;
  end;
  with BitBtn3 do begin
    Font.Name := 'lr oSVbN';
    Font.color := Clblack;
    Font.Style := [fsBold];
    Font.Height := 13;
    width := 81;
    height := 25;
    top := 160;
    left := Form7.ClientWidth - 100;
  end;
  with BitBtn4 do begin
    Font.Name := 'lr oSVbN';
    Font.color := ClRed;
    Font.Style := [fsBold, FsItalic];
    Font.Height := 17;
    height := 25;
    width := 81;
    top := 190;
    left := Form7.ClientWidth - 100;
  end;
  Image1.height := 30;
  Image1.width := 100;
  Image1.top := (Clientheight - Image1.height) div 2;
  Image1.left := (ClientWidth - Image1.width - 100) div 2;
  Image1.Visible := False;
  Timer1.Enabled := False;
  Form1.show;
  Form1.Timer1.Enabled := true;
end;

procedure datetimeout;{t\}
var
  number: string;
  pwidth: integer;
begin
  with Form7.Canvas do begin
    TextOut(80, 5, 'vZ');
//    FormatSettings.DateSeparator := '-';
//    FormatSettings.ShortDateFormat := 'm/dd/yyyy';
    number := DateToStr(Date);
    TextOut(200, 5, number);
    number := TimeToStr(Now);
    TextOut(300, 5, number);
    TextOut(400,  5, 'S');
    number := DateToStr(Date);
    pwidth := Textwidth('S');
    number := floatTostrF(LNGS,ffFixed,5,2);
    TextOut(400 + pwidth + 5, 5, number);
    pwidth := pwidth + TextWidth(number);
    TextOut(400 + pwidth + 5, 5,'mm');
    Font.height := 16;
    case btype of
      1:  number := 'ʕxg';
      2:  number := 'Ў^C~Oxg      sb`@' + floatTostrF(pich,ffFixed,5,1);
      3:  number := '^C~Oxg      sb`@' + floatTostrF(pich,ffFixed,5,1);
    end;
    TextOut(80, 320, number);
  end;
end;

procedure dataoutgridsetup;{WObh̐ݒ}
var
  JJ,II: integer;
  outtext: string;
  outtextb:string;
  Widtho,Widthi,Widths:  integer;
const
  Scolswidths = 40;
  Kcolswidths = 100;
begin
  with Form7 do begin
    with StringGrid1 do begin
      Visible := true;
      Enabled := true;
      BorderStyle := BsSingle;
      Options := [goFixedHorzLine,goHorzLine,goFixedVertLine,goVertLine];
      TabStop := False;
      Canvas.Font.Name := 'lr SVbN';
      Canvas.Font.height := 12;
      Font.Name := 'lr SVbN';
      Font.height := 15;
      Font.style := [fsBold];
      ParentCtl3D := True;
      ColCount := 5;
      rowCount := n + 1;
      left := 5;
      top := 40;
      DefaultRowHeight := 20;
      ColWidths[0] := Scolswidths;
      ColWidths[1] := Kcolswidths;
      ColWidths[2] := Kcolswidths;
      ColWidths[3] := Kcolswidths;
      ColWidths[4] := Kcolswidths;
      if n <= 10 then
        begin
          Clientheight := (DefaultRowHeight + 1) * (n + 1);
        end
        else ClientHeight := (DefaultRowHeight + 1) * 11;
      for jj := 1 to n do Cells[0 , jj] := intTostr(jj);
      Cells[1 , 0] := 'wW';
      Cells[2 , 0] := 'xW';
      Cells[3 , 0] := '@a';
      Cells[4 , 0] := 'tp';
      for jj := 1 to n do
        begin
          Widthi := Canvas.TextWidth('2');
          outtext := floatTostrF(X[JJ],ffFixed,5,2);
          Widtho := Canvas.TextWidth(outtext);
          Widths := Widtho div Widthi;
          if (widths >= 3) and (widths <= 8) then
                    for II := 1 to 9 - widths do outtext := ' ' + outtext;
          outtextb := outtext;
          if widths > 8 then outtextb := outtext;
          Cells[1 , JJ] := outtextb;
          outtext := floatTostrF(Y[JJ],ffFixed,5,2);
          Widtho := Canvas.TextWidth(outtext);
          Widths := Widtho div Widthi;
          if (widths >= 3) and (widths <= 8) then
                    for II := 1 to 9 - widths do outtext := ' ' + outtext;
          outtextb := outtext;
          if widths > 8 then outtextb := outtext;
          Cells[2 , JJ] := outtextb;
          outtext := floatTostrF(R[JJ],ffFixed,5,2);
          Widtho := Canvas.TextWidth(outtext);
          Widths := Widtho div Widthi;
          if (widths >= 3) and (widths <= 8) then
                    for II := 1 to 9 - widths do outtext := ' ' + outtext;
          outtextb := outtext;
          if widths > 8 then outtextb := outtext;
          Cells[3 , JJ] := outtextb;
          outtext := floatTostrF(LQ[JJ] / abs(R[JJ]) * 180 / pi,ffFixed,5,2);
          Widtho := Canvas.TextWidth(outtext);
          Widths := Widtho div Widthi;
          if (widths >= 3) and (widths <= 7) then
                    for II := 1 to 8 - widths do outtext := ' ' + outtext;
          outtextB := outtext + '';
          if widths > 7 then outtextb := ' ' + outtext + '';
          Cells[4 , JJ] := outtextb;
        end;
      Bitbtn1.setfocus;
      ClientWidth := Scolswidths + 1 + (Kcolswidths + 1) * 4;
    end;
    Canvas.Font.style := [fsBold];
    Canvas.Font.Color := Clblack;
    Canvas.Font.height := 16;
  end;
  datetimeout;{t\}
end;

procedure TForm7.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.show;
end;

procedure TForm7.BitBtn1Click(Sender: TObject);
begin
  Form6.show;
  hide;
  Form6.BitBtn3.SetFocus;
end;

procedure TForm7.BitBtn4Click(Sender: TObject);
begin
  hide;
  Form1.show;
end;

procedure TForm7.BitBtn3Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TForm7.StringGrid1Exit(Sender: TObject);
begin
  dataoutgridsetup;{WObh̐ݒ}
end;

procedure TForm7.BitBtn2Click(Sender: TObject);
var
  number: string;
  printwidth,Gend,pichprt:    integer;
  pwidth:                  integer;
  sic:                     double;
begin
  with printer do begin
    if Pageheight > Pagewidth then  printwidth := Pagewidth
                              else  printwidth := Pageheight;
    Image1.Visible := true;
    BeginDoc;
    Gend := 0;
    with Canvas do begin
      Font.Name := 'lr SVbN';
      Sic := printwidth / 600;
      Font.height := round(16 * Sic);
      pichprt := round(16 * Sic * 1.2);
      Font.style := [fsBold];
      Font.color := clBlack;
      Gend := Gend + pichprt;
      TextOut(round(80 * Sic), Gend, 'vZ');
//      FormatSettings.DateSeparator := '-';
//      FormatSettings.ShortDateFormat := 'm/dd/yyyy';
      number := DateToStr(Date);
      TextOut(round(200 * Sic), Gend, number);
      number := TimeToStr(Now);
      TextOut(round(300 * Sic), Gend, number);
      Gend := Gend + pichprt;
      TextOut(round(80 * sic), Gend, 'S');
      number := DateToStr(Date);
      pwidth := Textwidth('S');
      number := floatTostrF(LNGS,ffFixed,5,2);
      TextOut(round(80 * Sic) + pwidth, Gend, number);
      pwidth := pwidth + TextWidth(number);
      TextOut(round(80 * Sic) + pwidth, Gend,'mm');
      Gend := Gend + pichprt;
      case btype of
        1:  number := 'ʕxg';
        2:  number := 'Ў^C~Oxg      sb`@' + floatTostrF(pich,ffFixed,5,1);
        3:  number := '^C~Oxg      sb`@' + floatTostrF(pich,ffFixed,5,1);
      end;
      TextOut(round(80 * sic), Gend, number);
      Gend := Gend + pichprt;
      Subroutine.xyrprint(Gend);{ްprint}
    end;
    EndDoc;
  end;
  Timer1.Enabled := true;
  Timer1.Interval := 1000;
end;

procedure TForm7.Timer1Timer(Sender: TObject);
begin
  Image1.Visible := False;
  Timer1.Enabled := False;
end;

procedure TForm7.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  with StringGrid1.Canvas do
    begin
      Font := StringGrid1.Font;
      // ŒZ̐Fw
      if gdFixed in State then Brush.Color := StringGrid1.FixedColor
                          else Brush.Color := StringGrid1.Color;
      TextRect(Rect, Rect.Left + 2, Rect.Top + 2, StringGrid1.Cells[ACol, ARow]);
    end;
end;

end.

